Index: /trunk/Version.kmk
===================================================================
--- /trunk/Version.kmk	(revision 97571)
+++ /trunk/Version.kmk	(revision 97572)
@@ -35,5 +35,5 @@
 # new build. The define is available in every source file. Only even build numbers
 # will be published, odd numbers are set during development.
-VBOX_VERSION_BUILD  = 3
+VBOX_VERSION_BUILD  = 4
 # This can be overridden in LocalConfig.kmk or elsewhere.
 # For the convention, see checks near the end of Config.kmk.
Index: /trunk/debian/changelog
===================================================================
--- /trunk/debian/changelog	(revision 97571)
+++ /trunk/debian/changelog	(revision 97572)
@@ -1,2 +1,8 @@
+virtualbox-ose (7.0.4) unstable; urgency=low
+
+  * rebuild Debian package.
+
+ -- Oracle Corporation <info@virtualbox.org>  Fri, 18 Nov 2022 12:00:00 +0100
+
 virtualbox-ose (7.0.2) unstable; urgency=low
 
@@ -5,5 +11,4 @@
  -- Oracle Corporation <info@virtualbox.org>  Thu, 20 Oct 2022 12:00:00 +0200
 
-
 virtualbox-ose (7.0.0) unstable; urgency=low
 
Index: /trunk/doc/manual/user_ChangeLogImpl.xml
===================================================================
--- /trunk/doc/manual/user_ChangeLogImpl.xml	(revision 97571)
+++ /trunk/doc/manual/user_ChangeLogImpl.xml	(revision 97572)
@@ -72,5 +72,5 @@
   <sect1>
 
-    <title>Version 7.0.X (date tbd)</title>
+    <title>Version 7.0.4 (2022-11-18)</title>
 
     <para>This is a maintenance release. The following items were fixed and/or
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 97572)
@@ -8364,5 +8364,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x374c -> off=0x0 cb=000000000000002e uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x2e
-    db  'Oracle VM VirtualBox Version 7.0.2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.4 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47ae LB 0x371e -> off=0x0 cb=0000000000000080 uValue=00000000000c002e 'vga_modes'
 vga_modes:                                   ; 0xc47ae LB 0x80
@@ -9295,5 +9295,5 @@
   ; disGetNextSymbol 0xc7e55 LB 0x77 -> off=0x0 cb=0000000000000023 uValue=00000000000c36d5 '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e55 LB 0x23
-    db  'Oracle VM VirtualBox Version 7.0.2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.4', 000h
   ; disGetNextSymbol 0xc7e78 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c36f8 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e78 LB 0x2b
@@ -9327,3 +9327,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 0b8h
+    db  000h, 000h, 000h, 0b4h
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-3587bf90f44b6671cd8d4ff675c7a639 *VBoxVgaBios286.rom
+26f7b3cc54d49615b621b6fd468d8f12 *VBoxVgaBios286.rom
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 97572)
@@ -7825,5 +7825,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x374c -> off=0x0 cb=000000000000002e uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x2e
-    db  'Oracle VM VirtualBox Version 7.0.2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.4 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47ae LB 0x371e -> off=0x0 cb=0000000000000080 uValue=00000000000c002e 'vga_modes'
 vga_modes:                                   ; 0xc47ae LB 0x80
@@ -8756,5 +8756,5 @@
   ; disGetNextSymbol 0xc7e55 LB 0x77 -> off=0x0 cb=0000000000000023 uValue=00000000000c36d5 '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e55 LB 0x23
-    db  'Oracle VM VirtualBox Version 7.0.2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.4', 000h
   ; disGetNextSymbol 0xc7e78 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c36f8 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e78 LB 0x2b
@@ -8788,3 +8788,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 057h
+    db  000h, 000h, 000h, 053h
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-bff01b65a5c5655856cfb60ee21bdbf3 *VBoxVgaBios386.rom
+f2b250db4451f78b99ff1838793fc7dd *VBoxVgaBios386.rom
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 97572)
@@ -8533,5 +8533,5 @@
   ; disGetNextSymbol 0xc4780 LB 0x374c -> off=0x0 cb=000000000000002e uValue=00000000000c0000 '_msg_vga_init'
 _msg_vga_init:                               ; 0xc4780 LB 0x2e
-    db  'Oracle VM VirtualBox Version 7.0.2 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 7.0.4 VGA BIOS', 00dh, 00ah, 000h
   ; disGetNextSymbol 0xc47ae LB 0x371e -> off=0x0 cb=0000000000000080 uValue=00000000000c002e 'vga_modes'
 vga_modes:                                   ; 0xc47ae LB 0x80
@@ -9464,5 +9464,5 @@
   ; disGetNextSymbol 0xc7e55 LB 0x77 -> off=0x0 cb=0000000000000023 uValue=00000000000c36d5 '_vbebios_product_revision'
 _vbebios_product_revision:                   ; 0xc7e55 LB 0x23
-    db  'Oracle VM VirtualBox Version 7.0.2', 000h
+    db  'Oracle VM VirtualBox Version 7.0.4', 000h
   ; disGetNextSymbol 0xc7e78 LB 0x54 -> off=0x0 cb=000000000000002b uValue=00000000000c36f8 '_vbebios_info_string'
 _vbebios_info_string:                        ; 0xc7e78 LB 0x2b
@@ -9496,3 +9496,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 0b6h
+    db  000h, 000h, 000h, 0b2h
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-3fb5fac56105942ca6cc42ef47c14705 *VBoxVgaBios8086.rom
+e1273c20fb97abdb3fe4fc78cc0d2355 *VBoxVgaBios8086.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 97572)
@@ -1621,5 +1621,5 @@
   ; disGetNextSymbol 0xf0dba LB 0x3fa -> off=0x0 cb=0000000000000012 uValue=00000000000f0dba 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0dba LB 0x12
-    db  'VirtualBox 7.0.2', 000h, 000h
+    db  'VirtualBox 7.0.4', 000h, 000h
   ; disGetNextSymbol 0xf0dcc LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0dcc '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0dcc LB 0x8
@@ -19354,3 +19354,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0e8h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0e6h
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-8d80b7f5a954118b207e4e26c47fdeff *VBoxPcBios286.rom
+f627b04d359e4dc4c8238969f4005707 *VBoxPcBios286.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 97572)
@@ -1566,5 +1566,5 @@
   ; disGetNextSymbol 0xf0df4 LB 0x3fa -> off=0x0 cb=0000000000000012 uValue=00000000000f0df4 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0df4 LB 0x12
-    db  'VirtualBox 7.0.2', 000h, 000h
+    db  'VirtualBox 7.0.4', 000h, 000h
   ; disGetNextSymbol 0xf0e06 LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0e06 '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0e06 LB 0x8
@@ -19121,3 +19121,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0ddh
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0dbh
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-9e120b5241bf22b5c62cd5dd13eafaf8 *VBoxPcBios386.rom
+84c762031ffee2692bb1236b9163f52c *VBoxPcBios386.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 97572)
@@ -1621,5 +1621,5 @@
   ; disGetNextSymbol 0xf0dba LB 0x3fa -> off=0x0 cb=0000000000000012 uValue=00000000000f0dba 'bios_cvs_version_string'
 bios_cvs_version_string:                     ; 0xf0dba LB 0x12
-    db  'VirtualBox 7.0.2', 000h, 000h
+    db  'VirtualBox 7.0.4', 000h, 000h
   ; disGetNextSymbol 0xf0dcc LB 0x3e8 -> off=0x0 cb=0000000000000008 uValue=00000000000f0dcc '_bios_prefix_string'
 _bios_prefix_string:                         ; 0xf0dcc LB 0x8
@@ -19832,3 +19832,3 @@
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0              ; 0xffff0 orgs.asm:2114
   ; disGetNextSymbol 0xffff5 LB 0xb -> off=0xb cb=0000000000000000 uValue=0000000000100000 '_dummy_addr_0x100000'
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 057h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 055h
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 97571)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 97572)
@@ -1,1 +1,1 @@
-959fb6e00dc9da4eb73fac998749c21a *VBoxPcBios8086.rom
+1cd66c098811d5e58f8409d647f3a55a *VBoxPcBios8086.rom