Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.cpp	(revision 97679)
@@ -409,26 +409,20 @@
                     this, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated));
 #ifdef VBOX_IS_QT6_OR_LATER /** @todo qt6: textActivated was added in 5.14 actually */
-            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::textActivated),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textActivated));
+            connect(m_pComboBox, &QComboBox::textActivated,
+                    this, &QIComboBox::textActivated);
 #else
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::activated),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::activated));
+                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textActivated));
 #endif
             connect(m_pComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
                     this, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged));
-#ifndef VBOX_IS_QT6_OR_LATER
-            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::currentIndexChanged),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::currentIndexChanged));
-#endif
             connect(m_pComboBox, &QComboBox::currentTextChanged, this, &QIComboBox::currentTextChanged);
             connect(m_pComboBox, &QComboBox::editTextChanged, this, &QIComboBox::editTextChanged);
 #ifdef VBOX_IS_QT6_OR_LATER /** @todo qt6: textHighlighted was added in 5.14 actually */
-            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::textHighlighted),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textHighlighted));
+            connect(m_pComboBox, &QComboBox::textHighlighted,
+                    this, &QIComboBox::textHighlighted);
 #else
             connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::highlighted),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::highlighted));
-            connect(m_pComboBox, static_cast<void(QComboBox::*)(const QString &)>(&QComboBox::highlighted),
-                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::highlighted));
+                    this, static_cast<void(QIComboBox::*)(const QString &)>(&QIComboBox::textHighlighted));
 #endif
             /* Add combo-box into layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIComboBox.h	(revision 97679)
@@ -53,16 +53,8 @@
     void activated(int iIndex);
     /** Notifies listeners about user chooses an item with @a strText in the combo-box. */
-#ifdef VBOX_IS_QT6_OR_LATER /** @todo qt6: textHighlighted was added in 5.14 actually */
     void textActivated(const QString &strText);
-#else
-    void activated(const QString &strText);
-#endif
 
     /** Notifies listeners about current item changed to item with @a iIndex. */
     void currentIndexChanged(int iIndex);
-#ifndef VBOX_IS_QT6_OR_LATER
-    /** Notifies listeners about current item changed to item with @a strText. */
-    void currentIndexChanged(const QString &strText);
-#endif
 
     /** Notifies listeners about current combo-box text is changed to @a strText. */
@@ -74,9 +66,5 @@
     void highlighted(int iIndex);
     /** Notifies listeners about user highlighted an item with @a strText in the popup list-view. */
-#ifdef VBOX_IS_QT6_OR_LATER /** @todo qt6: textHighlighted was added in 5.14 actually */
     void textHighlighted(const QString &strText);
-#else
-    void highlighted(const QString &strText);
-#endif
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 97679)
@@ -150,5 +150,5 @@
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIWizardAddCloudVMPageExpert::sltHandleProviderComboChange);
-    connect(m_pProviderComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated),
+    connect(m_pProviderComboBox, &QIComboBox::activated,
             this, &UIWizardAddCloudVMPageExpert::sltHandleProviderComboChange);
     connect(m_pProfileComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged),
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageSource.cpp	(revision 97679)
@@ -368,5 +368,5 @@
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIWizardAddCloudVMPageSource::sltHandleProviderComboChange);
-    connect(m_pProviderComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated),
+    connect(m_pProviderComboBox, &QIComboBox::activated,
             this, &UIWizardAddCloudVMPageSource::sltHandleProviderComboChange);
     connect(m_pProfileComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged),
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 97679)
@@ -323,5 +323,5 @@
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIWizardImportAppPageExpert::sltHandleSourceComboChange);
-    connect(m_pSourceComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated),
+    connect(m_pSourceComboBox, &QIComboBox::activated,
             this, &UIWizardImportAppPageExpert::sltHandleSourceComboChange);
     connect(m_pFileSelector, &UIEmptyFilePathSelector::pathChanged,
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 97679)
@@ -186,5 +186,5 @@
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIWizardNewCloudVMPageExpert::sltHandleProviderComboChange);
-    connect(m_pProviderComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated),
+    connect(m_pProviderComboBox, &QIComboBox::activated,
             this, &UIWizardNewCloudVMPageExpert::sltHandleProviderComboChange);
     connect(m_pProfileComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged),
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 97678)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageSource.cpp	(revision 97679)
@@ -430,5 +430,5 @@
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigCloudProfileChanged,
             this, &UIWizardNewCloudVMPageSource::sltHandleProviderComboChange);
-    connect(m_pProviderComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::activated),
+    connect(m_pProviderComboBox, &QIComboBox::activated,
             this, &UIWizardNewCloudVMPageSource::sltHandleProviderComboChange);
     connect(m_pProfileComboBox, static_cast<void(QIComboBox::*)(int)>(&QIComboBox::currentIndexChanged),