Index: /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml	(revision 97869)
+++ /trunk/doc/manual/en_US/man_VBoxManage-cloud.xml	(revision 97870)
@@ -50,5 +50,5 @@
     <!-- Cloud list -->
     <!-- The 'id' is mandatory and must start with 'synopsis-'. -->
-    <cmdsynopsis id="synopsis-vboxmanage-cloudlist-instances">
+    <cmdsynopsis id="synopsis-vboxmanage-instances-cloudlist">
       <command>VBoxManage cloud</command>
         <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -60,5 +60,5 @@
         <arg>--compartment-id=<replaceable>string</replaceable></arg>
     </cmdsynopsis>
-    <cmdsynopsis id="synopsis-vboxmanage-cloudlist-images">
+    <cmdsynopsis id="synopsis-vboxmanage-images-cloudlist">
       <command>VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -132,5 +132,5 @@
 
      <!-- Cloud image commands -->
-      <cmdsynopsis id="synopsis-vboxmanage-cloudimage-create" sepchar=" "> <!-- The 'id' is mandatory and must start with 'synopsis-'. -->
+      <cmdsynopsis id="synopsis-vboxmanage-create-cloudimage" sepchar=" "> <!-- The 'id' is mandatory and must start with 'synopsis-'. -->
         <command>VBoxManage cloud</command>
           <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -144,5 +144,5 @@
           <arg>--instance-id=<replaceable>unique id</replaceable></arg>
       </cmdsynopsis>
-      <cmdsynopsis id="synopsis-vboxmanage-cloudimage-info" sepchar=" ">
+      <cmdsynopsis id="synopsis-vboxmanage-info-cloudimage" sepchar=" ">
         <command>VBoxManage cloud</command>
         <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -153,5 +153,5 @@
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
       </cmdsynopsis>
-      <cmdsynopsis id="synopsis-vboxmanage-cloudimage-delete" sepchar=" ">
+      <cmdsynopsis id="synopsis-vboxmanage-delete-cloudimage" sepchar=" ">
         <command>VBoxManage cloud</command>
         <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -162,5 +162,5 @@
         <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
       </cmdsynopsis>
-      <cmdsynopsis id="synopsis-vboxmanage-cloudimage-import" sepchar=" ">
+      <cmdsynopsis id="synopsis-vboxmanage-import-cloudimage" sepchar=" ">
         <command>VBoxManage cloud</command>
         <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -173,5 +173,5 @@
         <arg>--object-name=<replaceable>name</replaceable></arg>
       </cmdsynopsis>
-      <cmdsynopsis id="synopsis-vboxmanage-cloudimage-export" sepchar=" ">
+      <cmdsynopsis id="synopsis-vboxmanage-export-cloudimage" sepchar=" ">
         <command>VBoxManage cloud</command>
         <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -239,5 +239,5 @@
 
     <!-- Cloud commands common options  -->
-    <refsect2 id="vboxmanage-cloud-common-options">
+    <refsect2 id="vboxmanage-options-cloud-common">
       <title>Common options</title>
       <remark role="help-scope" condition="GLOBAL"/>
@@ -257,5 +257,5 @@
 
     <!-- Cloud list commands -->
-    <refsect2 id="vboxmanage-cloudlist-instances">
+    <refsect2 id="vboxmanage-instances-cloudlist">
       <title>cloud list instances</title>
       <remark role="help-copy-synopsis"/>
@@ -283,5 +283,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudlist-images">
+    <refsect2 id="vboxmanage-images-cloudlist">
       <title>cloud list images</title>
       <remark role="help-copy-synopsis"/>
@@ -419,5 +419,5 @@
 
     <!-- Cloud image commands -->
-    <refsect2 id="vboxmanage-cloudimage-create">
+    <refsect2 id="vboxmanage-create-cloudimage">
       <title>cloud image create</title>
       <remark role="help-copy-synopsis"/>
@@ -451,5 +451,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudimage-info">
+    <refsect2 id="vboxmanage-info-cloudimage">
       <title>cloud image info</title>
       <remark role="help-copy-synopsis"/>
@@ -464,5 +464,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudimage-delete">
+    <refsect2 id="vboxmanage-delete-cloudimage">
       <title>cloud image delete</title>
       <remark role="help-copy-synopsis"/>
@@ -477,5 +477,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudimage-import">
+    <refsect2 id="vboxmanage-import-cloudimage">
       <title>cloud image import</title>
       <remark role="help-copy-synopsis"/>
@@ -509,5 +509,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudimage-export">
+    <refsect2 id="vboxmanage-export-cloudimage">
       <title>cloud image export</title>
       <remark role="help-copy-synopsis"/>
Index: /trunk/doc/manual/en_US/man_VBoxManage-cloudinstance.xml
===================================================================
--- /trunk/doc/manual/en_US/man_VBoxManage-cloudinstance.xml	(revision 97869)
+++ /trunk/doc/manual/en_US/man_VBoxManage-cloudinstance.xml	(revision 97870)
@@ -47,5 +47,5 @@
 
   <refsynopsisdiv>
-     <cmdsynopsis id="synopsis-vboxmanage-cloudinstance-create" sepchar=" ">
+     <cmdsynopsis id="synopsis-vboxmanage-create-cloudinstance" sepchar=" ">
       <command moreinfo="none">VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -67,5 +67,5 @@
       <arg>--launch-mode=<replaceable>NATIVE/EMULATED/PARAVIRTUALIZED</replaceable></arg>
     </cmdsynopsis>
-    <cmdsynopsis id="synopsis-vboxmanage-cloudinstance-info" sepchar=" ">
+    <cmdsynopsis id="synopsis-vboxmanage-info-cloudinstance" sepchar=" ">
       <command moreinfo="none">VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -75,5 +75,5 @@
       <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
     </cmdsynopsis>
-    <cmdsynopsis id="synopsis-vboxmanage-cloudinstance-terminate" sepchar=" ">
+    <cmdsynopsis id="synopsis-vboxmanage-terminate-cloudinstance" sepchar=" ">
       <command moreinfo="none">VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -83,5 +83,5 @@
       <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
     </cmdsynopsis>
-    <cmdsynopsis id="synopsis-vboxmanage-cloudinstance-start" sepchar=" ">
+    <cmdsynopsis id="synopsis-vboxmanage-start-cloudinstance" sepchar=" ">
       <command moreinfo="none">VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -91,5 +91,5 @@
       <arg choice="req">--id=<replaceable>unique id</replaceable></arg>
     </cmdsynopsis>
-    <cmdsynopsis id="synopsis-vboxmanage-cloudinstance-pause" sepchar=" ">
+    <cmdsynopsis id="synopsis-vboxmanage-pause-cloudinstance" sepchar=" ">
       <command moreinfo="none">VBoxManage cloud</command>
       <arg choice="req">--provider=<replaceable>name</replaceable></arg>
@@ -121,5 +121,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudinstance-create">
+    <refsect2 id="vboxmanage-create-cloudinstance">
       <title>cloud instance create</title>
       <remark role="help-copy-synopsis"/>
@@ -177,5 +177,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudinstance-info">
+    <refsect2 id="vboxmanage-info-cloudinstance">
       <title>cloud instance info</title>
       <para>
@@ -189,5 +189,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudinstance-terminate">
+    <refsect2 id="vboxmanage-terminate-cloudinstance">
       <title>cloud instance termination</title>
       <para>
@@ -201,5 +201,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudinstance-start">
+    <refsect2 id="vboxmanage-start-cloudinstance">
       <title>cloud instance start</title>
       <para>
@@ -213,5 +213,5 @@
     </refsect2>
 
-    <refsect2 id="vboxmanage-cloudinstance-pause">
+    <refsect2 id="vboxmanage-pause-cloudinstance">
       <title>cloud instance pause</title>
       <para>