Index: trunk/tools/kBuildTools/VBoxXGccAmd64LinuxGnu.kmk
===================================================================
--- trunk/tools/kBuildTools/VBoxXGccAmd64LinuxGnu.kmk	(revision 97741)
+++ trunk/tools/kBuildTools/VBoxXGccAmd64LinuxGnu.kmk	(revision 97991)
@@ -91,5 +91,5 @@
 define TOOL_VBoxXGccAmd64LinuxGnu_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VBoxXGccAmd64LinuxGnu_CC) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
@@ -102,5 +102,5 @@
 define TOOL_VBoxXGccAmd64LinuxGnu_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VBoxXGccAmd64LinuxGnu_CXX) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
@@ -113,5 +113,5 @@
 define TOOL_VBoxXGccAmd64LinuxGnu_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_VBoxXGccAmd64LinuxGnu_AS) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
Index: trunk/tools/kBuildTools/VBoxXGccX86RedHatLinux.kmk
===================================================================
--- trunk/tools/kBuildTools/VBoxXGccX86RedHatLinux.kmk	(revision 97741)
+++ trunk/tools/kBuildTools/VBoxXGccX86RedHatLinux.kmk	(revision 97991)
@@ -90,5 +90,5 @@
 define TOOL_VBoxXGccX86RedHatLinux_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VBoxXGccX86RedHatLinux_CC) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
@@ -101,5 +101,5 @@
 define TOOL_VBoxXGccX86RedHatLinux_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VBoxXGccX86RedHatLinux_CXX) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
@@ -112,5 +112,5 @@
 define TOOL_VBoxXGccX86RedHatLinux_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_VBoxXGccX86RedHatLinux_AS) -c \
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs)) \
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs)) \
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP \
 		-o $(obj) \
Index: trunk/tools/kBuildTools/VBoxXcode62.kmk
===================================================================
--- trunk/tools/kBuildTools/VBoxXcode62.kmk	(revision 97741)
+++ trunk/tools/kBuildTools/VBoxXcode62.kmk	(revision 97991)
@@ -190,5 +190,5 @@
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_VBoxXcode62_CC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		$(abspath $(source))\
@@ -204,5 +204,5 @@
 define TOOL_VBoxXcode62_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VBoxXcode62_ENV_SETUP) $(TOOL_VBoxXcode62_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		-o $(obj)\
@@ -234,5 +234,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_VBoxXcode62_CXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep)\
 		-Wp,-MP\
@@ -249,5 +249,5 @@
 define TOOL_VBoxXcode62_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VBoxXcode62_ENV_SETUP) $(TOOL_VBoxXcode62_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep)\
 		-Wp,-MP\
@@ -280,5 +280,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_VBoxXcode62_OBJC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		$(abspath $(source))\
@@ -294,5 +294,5 @@
 define TOOL_VBoxXcode62_COMPILE_OBJC_CMDS
 	$(QUIET)$(TOOL_VBoxXcode62_ENV_SETUP) $(TOOL_VBoxXcode62_OBJC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		-o $(obj)\
@@ -324,5 +324,5 @@
 		--kObjCache-cpp $(outbase).mii\
 		$(TOOL_VBoxXcode62_OBJCXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		$(abspath $(source))\
@@ -338,5 +338,5 @@
 define TOOL_VBoxXcode62_COMPILE_OBJCXX_CMDS
 	$(QUIET)$(TOOL_VBoxXcode62_ENV_SETUP) $(TOOL_VBoxXcode62_OBJCXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		-o $(obj)\
@@ -365,5 +365,5 @@
 define TOOL_VBoxXcode62_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_VBoxXcode62_ENV_SETUP) $(TOOL_VBoxXcode62_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MP\
 		-o $(obj)\